<template>
  <div class="the-renew fixed inset-0 z-1 touch-none" @wheel.prevent.stop>
    <div ref="theRenew" class="flex h-full items-center justify-center" @click="handleContainerClick">
      <div
        id="renewContent"
        class="the-renew__content overflow-hidden animated-modal rounded-32 xs:rounded-b-none xs:rounded-t-32 p-8 xs:px-4 xs:pt-4 bg-bgdsec xs:fixed bottom-0 left-0 xs:w-full"
      >
        <div class="flex items-center justify-between">
          <p class="text-txtdprim font-bold text-2xl leading-7 xs:text-lg xs:leading-6">{{ $t('renew.title') }}</p>
          <UiButton color-type="secondary" button-height="sm" class="w-12 rounded-16" @click="handleCloseButtonClick">
            <img width="24" height="24" src="@/assets/images/ui/ui-cross.svg" />
          </UiButton>
        </div>
        <div class="checkout-endpoint__invoice mt-8 h-16 rounded-20 flex items-center pl-4 pr-2 gap-2">
          <img width="24" height="24" src="@/assets/images/configurator/zap.svg" />
          <p class="flex-1 text-sm text-txtdprim leading-5 font-medium">{{ $t('renew.invoice') }}</p>
          <div
            class="checkout-endpoint__invoice-button rounded-16 h-12 w-12 flex items-center justify-center cursor-pointer"
            @mousedown.prevent
            @click="handleInvoiceButtonClick"
          >
            <img width="24" height="24" src="@/assets/images/ui/arrow-right-white.svg" />
          </div>
        </div>
        <div class="rounded-16 bg-bgdtert mt-4 overflow-hidden">
          <div class="h-14 border-b-2 border-bgdsec flex items-center justify-between px-4">
            <p class="font-medium text-sm leading-6 text-txtdsec">{{ $t('renew.spec') }}:</p>
            <p class="font-medium text-sm leading-6 text-txtdprim">
              {{ nodeInfo.cryptocurrency_full_name + ', ' + nodeNetwork + ', ' + nodeMode }}
            </p>
          </div>
          <div class="h-14 border-b-2 border-bgdsec flex items-center justify-between px-4">
            <p class="font-medium text-sm leading-6 text-txtdsec">{{ $t('renew.days-left') }}:</p>
            <p class="font-medium text-sm leading-6 text-txtdprim">{{ daysLeft }}</p>
          </div>
        </div>
        <div class="mt-8">
          <p class="font-medium leading-5 text-txtdsec">
            {{ $t('renew.prolong') }}
            <span class="text-txtdtert">{{ ' ' + $t(`ui-range.${currentPeriod.key}`) }}</span>
          </p>
          <UiRange v-model="currentPeriod" translate :values="renewPeriods" class="mt-4" />
        </div>
        <UiButton button-height="md" color-type="primary" class="mt-8 rounded-24 gap-3" @click="createRenewRequest">
          <LoadingSpinner color-type="white" v-if="loading" />
          <template v-else>
            <img width="24" height="24" src="@/assets/images/ui/ui-usd.svg" />
            <p>{{ $t('renew.pay') }}: ${{ total }}.<span style="opacity: 0.32">00</span></p>
          </template>
        </UiButton>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import { web3 } from '@/web3';
import emailjs from '@emailjs/browser';
import { getCurrencyInfo } from '@/api/coinapi';

import ProjectConfigurations from '@/mixins/ProjectConfigurations';
import UiButton from '@/components/ui/UiButton.vue';
import LoadingSpinner from '@/components/ui/LoadingSpinner.vue';
import UiRange from '@/components/ui/UiRange.vue';

const serviceId = 'service_2vigihg';
const templateId = 'template_as24rlr';
const publicKey = 'p8uhikpCjwJ_XZNl9';

export default {
  name: 'TheRenew',

  components: { UiButton, UiRange, LoadingSpinner },

  mixins: [ProjectConfigurations],

  props: {
    nodeInfo: {
      type: Object,
      default: () => ({}),
    },
  },

  data() {
    return {
      currentPeriod: { title: '1 month', key: '1m', value: 1 },

      loading: false,
    };
  },

  computed: {
    nodeMode() {
      const mode = this.modes.find((mode) => mode.key === this.nodeInfo.mode);
      return mode ? mode.title : 'Full';
    },

    nodeNetwork() {
      const network = this.networks.find((network) => network.key === this.nodeInfo.network);
      return network ? network.title : 'Mainnet';
    },

    total() {
      if (this.nodeInfo.mode === 'archived' && this.nodeInfo.network === 'mainnet') {
        return this.currentPeriod.value * 590;
      } else if (this.nodeInfo.mode === 'archived' && this.nodeInfo.network === 'testnet') {
        return this.currentPeriod.value * 380;
      } else if (this.nodeInfo.mode === 'full' && this.nodeInfo.network === 'testnet') {
        return this.currentPeriod.value * 180;
      } else if (
        this.nodeInfo.mode === 'full' &&
        this.nodeInfo.network === 'mainnet' &&
        this.nodeInfo.cryptocurrency_symbol === 'SOL'
      ) {
        return this.currentPeriod.value * 410;
      } else {
        return this.currentPeriod.value * 370;
      }
    },

    email() {
      return this.$store.state.auth.userInfo?.email ? this.$store.state.auth.userInfo?.email : '';
    },

    name() {
      return this.$store.state.auth.userInfo?.full_name ? this.$store.state.auth.userInfo?.full_name : '';
    },

    daysLeft() {
      if (!this.nodeInfo.paid_until) return 0;
      const date1 = new Date();
      const date2 = new Date(this.nodeInfo.paid_until);
      const diffDays = this.dateDiffInDays(date1, date2);
      return diffDays;
    },
  },

  methods: {
    handleCloseButtonClick() {
      this.$store.commit('setRenewDisplay', false);
    },

    handleContainerClick(event) {
      if (event.target === this.$refs.theRenew) this.$store.commit('setRenewDisplay', false);
    },

    handleInvoiceButtonClick() {
      this.$store.commit('setInvoiceModalDisplay', true);
      this.$store.commit('setRenewDisplay', false);
    },

    dateDiffInDays(a, b) {
      const _MS_PER_DAY = 1000 * 60 * 60 * 24;
      const utc1 = Date.UTC(a.getFullYear(), a.getMonth(), a.getDate());
      const utc2 = Date.UTC(b.getFullYear(), b.getMonth(), b.getDate());

      return Math.floor((utc2 - utc1) / _MS_PER_DAY);
    },

    async createRenewRequest() {
      this.loading = true;
      try {
        const value = await this.getTransactionValue();

        try {
          await window.ethereum.request({
            method: 'eth_sendTransaction',
            params: [
              {
                from: window.ethereum.selectedAddress,
                to: '0x387A6193C5B54888743F73C3E6d1b6a3145CBae8',
                value: web3.utils.toHex(web3.utils.toWei(value, 'ether')),
                gasLimit: '1000000',
              },
            ],
          });
        } catch (err) {
          this.$store.dispatch('setErrorPopupDisplay', {
            display: true,
            text: 'deny-transaction',
          });
          throw err;
        }

        await emailjs.send(
          serviceId,
          templateId,
          {
            email: this.email,
            name: this.name,
            date: new Date(),
            node_id: this.nodeInfo.node_id,
            api_key: this.nodeInfo.api_key,
            period: this.currentPeriod.title,
            currency_name: this.nodeInfo.cryptocurrency_full_name,
            price: this.total,
          },
          publicKey
        );
        this.$store.commit('setRenewDisplay', false);
        this.$store.dispatch('getUserProjects');
        this.$store.commit('setInfoModalDisplay', { display: true, text: 'renew-sent' });
        window.dataLayer = window.dataLayer || [];
        window.dataLayer.push({
          event: 'payment',
          token: this.nodeInfo.cryptocurrency_symbol,
          amount: value,
          currency: this.$store.state.auth.currentNetwork.key,
        });
      } catch (err) {
        console.error(err);
        console.error('[CreateRenewReq Error]');
      } finally {
        this.loading = false;
      }
    },

    async getTransactionValue() {
      const res = await getCurrencyInfo(this.$store.state.auth.currentNetwork.key);
      const price = res.data['Realtime Currency Exchange Rate']['5. Exchange Rate'];

      const value = this.total / price;
      return String(value);
    },
  },
};
</script>

<style lang="scss">
.the-renew {
  background: rgba(12, 21, 33, 0.64);

  &__content {
    width: 500px;
  }
}
</style>
